#/usr/bin/bash !
# -*- encoding: utf-8 -*-
#Proton Cmp
# Writer : Aminrngbr
# Date: 2023.2.4
# Telegram Username: @aminrngbr
#TeamKit Group

import platform
import os, sys, json
import datetime
import time
import requests
import signal
import colorama
import keyboard
import threading
from Prints import printW, printE, printO

# Value code ======================
config = os.path.exists(os.path.join(os.getcwd(), 'config.json'))
configData = json.loads(open('config.json', 'r+').read())
__lib__ = configData["Lib"]
# =================================

__version__ = configData.get("Version")

__set__ = configData.get('VCA', 'Test')

def handler(signum, frame):
    print("Cannot exit terminal. Please use 'exit()' command to exit.")

signal.signal(signal.SIGINT, handler)

commands = {
"run": "Run the entered code",
"clear": "Clear all entered code",
"online": "Check if the device is connected to the internet",
"exit": "Exit Cmp softwar",
"v or version": "Show version Proton Cmp",
"help": "Display available commands and their descriptions"
}

def libsyss(lib):
    codes = """"""
    try:
        for name in lib:
            reads = open(name, 'r+').read()
            codes += f"""
{reads}
            """
    except Exception as e:
            cmds.clear_cmd()
            printE(f"Error Add File {name} !")
            sys.exit()
    codess = f"""
import os,sys,re,easygui, pyautogui, colorama, json, cmds, platform, time

# Status Warning Print Function
def printW(text = "") -> print:
    print(colorama.Fore.YELLOW+text+colorama.Fore.WHITE)
    
# Status Error Print Function
def printE(text = "") -> print:
    print(colorama.Fore.RED+text+colorama.Fore.WHITE)
    
# Status Ok Print Function
def printO(text = "") -> print:
    print(colorama.Fore.GREEN+text+colorama.Fore.WHITE)
    
def readfile(path) -> str:
    try:
        return str(open(path, 'r+').read())
    except open as e:
        Prints.printE('Error !')
        sys.exit()
        
# Clear exec Terminal stdout
def clearCL() -> None:
    os.system('clear')
    
# Clear exec Terminal stdout
def clearCW() -> None:
    os.system('cls')
    
# Clear exec Terminal stdout
def clearCJ() -> None:
    os.system('clear')

{codes}

if __name__ == '__main__':
    """.replace(':=', '=').replace('pkgs main', '').replace('/*', '#').replace('*/', '#').replace('echo', 'print').replace('{|', ':').replace('|}', '').replace('<"""', '"""').replace('""">', '"""').replace('str |', 'str').replace('int |', 'int').replace('float |', 'float').replace('type |', 'type').replace('-;', '').replace('<<', '{').replace('>>', '}').replace('func ', 'def ').replace('glob', 'global').replace('complex |', 'complex').replace('tuple |', 'tuple').replace('range |', 'range').replace('dict |', 'dict').replace('set |', 'set').replace('frozenset |', 'frozenset').replace('bool |', 'bool').replace('bytes |', 'bytes').replace('bytearray |', 'bytearray').replace('memoryview |', 'memoryview').replace('null |', 'None').replace('len |', 'len').replace(' :in: ', ' in ').replace('@$', 'not').replace('<<>>', 'or').replace('<>', 'and').replace('::', ':').replace('str_upper()', 'upper()').replace('str_lower()', 'lower()').replace('str_strip()', 'strip()').replace('str_split', 'split').replace('format |', 'format').replace('else if', 'elif').replace('true |', 'True').replace('false |', 'False').replace('public |', '').replace('private |', '_').replace(' new ', '').replace('argv()', 'sys.argv').replace('pt%', '').replace('%pt', '').replace('sleep(', 'time.sleep(').replace('&;', '').replace('--', '    ').replace('&', '')
    return str(codess)

def help():
    printO("Available commands:")
    for command, description in commands.items():
        printO(f"{command}: {description}")

for i in range(101):
 text = "Pkg"
 load = '/'
 time.sleep(0.000001)
 if i > 15:
  text = "Files"
  load = '|'
 if i > 23:
  text = "system value stream"
  load = '\ '
 if i > 45:
  text = "Libray"
  load = '/'
 if i > 65:
  text = "Back End"
  load = '\ '
 if i > 75:
  text = "Start"
  load = '...'
 if i < 100:
  print(f"{i}% Loading {text} Cmp {load}", end="\r")
  if platform.system() == "Linux":
   os.system("clear")
  else:
   os.system("cls")
 else:
  print(f"Starting cmp ...", end="\r")
  if platform.system() == "Linux":
   time.sleep(2.5)
   os.system('clear')
  else:
   time.sleep(2.8)
   os.system('cls')

class ProtonCodeCmp:
    def __init__(self):
        self.date = datetime.datetime.now()
        self.code = libsyss(__lib__)

    def display_header(self):
       printO(f"Proton {__set__} Cmp {platform.system()} Version {__version__} {self.date.year}:{self.date.month}:{self.date.day} & {self.date.hour}:{self.date.minute}:{self.date.second} :")

    def clear_tm(self):
        if platform.system() == "Linux":
            os.system("clear")
        elif platform.system() == "Windows":
            os.system("cls")
        self.display_header()

    def run_code(self):
        self.clear_tm()
        try:
            start = datetime.datetime.now().second
            exec(self.code.replace(':=', '=').replace('pkgs main', '').replace('/*', '#').replace('*/', '#').replace('echo', 'print').replace('{|', ':').replace('|}', '').replace('<"""', '"""').replace('""">', '"""').replace('str |', 'str').replace('int |', 'int').replace('float |', 'float').replace('type |', 'type').replace('-;', '').replace('<<', '{').replace('>>', '}').replace('func ', 'def ').replace('glob', 'global').replace('complex |', 'complex').replace('tuple |', 'tuple').replace('range |', 'range').replace('dict |', 'dict').replace('set |', 'set').replace('frozenset |', 'frozenset').replace('bool |', 'bool').replace('bytes |', 'bytes').replace('bytearray |', 'bytearray').replace('memoryview |', 'memoryview').replace('null |', 'None').replace('len |', 'len').replace(' :in: ', ' in ').replace('@$', 'not').replace('<<>>', 'or').replace('<>', 'and').replace('::', ':').replace('str_upper()', 'upper()').replace('str_lower()', 'lower()').replace('str_strip()', 'strip()').replace('str_split', 'split').replace('format |', 'format').replace('else if', 'elif').replace('true |', 'True').replace('false |', 'False').replace('public |', '').replace('private |', '_').replace(' new ', '').replace('argv()', 'sys.argv').replace('pt%', '').replace('%pt', '').replace('sleep(', 'time.sleep(').replace('&;', '').replace('--', '     ').replace('&', ''))
            end = datetime.datetime.now().second
            print(f"Time Run : {str((start - end) + 1).replace('-', '')}S")
        except Exception as e:
            print(e)
            self.code = libsyss(__lib__)
    def start(self):
        self.display_header()
        if not os.path.exists('1.sjk'):
            open('1.sjk', 'w').write('0')
        while True:
            codes = input(colorama.Fore.RED+">>>"+colorama.Fore.WHITE)
            if codes == "clear":
                self.code = ""
                self.clear_tm()
                continue
            if codes == "help":
                help()
            if codes == 'restart':
                cmp.start()
            if codes == "uname":
                for items in platform.uname():
                    printW(items)
                printW(f"Paths :{son.dumps(sys.path, indent=3)}")
            if codes == "exit":
                break
                sys.exit()
            if codes == "v" or codes == "version":
                printW(f"{__version__} {__set__}")
            if codes == "online":
             try:
              requests.get("https://google.com")
              printO("Is Devive Online")
             except Exception as e:
              printW("is Device Offline")
            if codes == "run":
                try:
                 self.run_code()
                except Exception as e:
                 print(e)
                 self.code = """"""
                continue
            else:
                self.code += f"{codes}\n"
                
try:
    cmp = ProtonCodeCmp()
    cmp.start()
except Exception as e:
    printW(e)
    printE("Proton Cmp Error !")
    time.sleep(10)
    sys.exit()