import setuptools

with open('README.md', "r") as f:
    long_description = f.read()

setuptools.setup(
    name="ProtonQ",
    version="1.0.0",
    author="Amin Rngbr",
    author_email="rngbramin@gmail.com",
    description="A simple and understandable programming language for beginners (:",
    long_description=long_description,
    long_description_content_type="text/markdown",
    url="https://github.com/aminrngbr1122",
    keywords="proton",
    packages=['ProtonQ'],
    entry_points={
        'console_scripts': [
            'proton = ProtonQ.protonCmp.py',
        ],
    },
    install_requires=[
        "pyautogui",
        "easygui",
        "colorama"    
    ],
    python_requires=">=3.4",
)
