#/usr/bin/bash !
# -*- encoding: utf-8 -*-
#Proton Cmp
# Writer : Aminrngbr
# Date: 2023.2.4
# Telegram Username: @aminrngbr
#TeamKit Group

# Import result libray ============
import os,sys,re,easygui, pyautogui, colorama, json
from datetime import datetime
import asyncio
# =================================

# Import Programing file ==========
from Prints import printE, printO, printW
from cmds import clear_cmd
from opt import opts
from path import Get_path
from read import readfile
from getLib import addLib
from libsys import libsyss
from exec import runcode
# =================================

# Value code ======================
config = os.path.exists(os.path.join(os.getcwd(), 'config.json'))
configData = json.loads(open('config.json', 'r+').read())
__lib__ = configData["Lib"]
now = datetime.now()
open('Log.txt', 'w')
code = ""
codes = """"""
# =================================

printO(f'Proton {configData.get("Version")} output:')

if not config:
    clear_cmd()
    printE(f"config.json file error not found!")
    
if __name__ == '__main__':
    opts()
    path, info = Get_path()
    # 
    if info == 'path':
        code = readfile(path)
    elif info == 'code':
        code = path
    else:
        sys.exit()
    # 
    code = addLib(code)
    code = libsyss(__lib__, code)
    if '%pt' in code and 'pt%' in code:
        pass
    else:
        clear_cmd()
        printE(f'Proton File or code {path} Error ! %pt and pt% Not Found !')
        sys.exit()
    codes = f"""
import os,sys,re,easygui, pyautogui, colorama, json, cmds, platform, time

# Status Warning Print Function
def printW(text = "") -> print:
    print(colorama.Fore.YELLOW+text+colorama.Fore.WHITE)
    
# Status Error Print Function
def printE(text = "") -> print:
    print(colorama.Fore.RED+text+colorama.Fore.WHITE)
    
# Status Ok Print Function
def printO(text = "") -> print:
    print(colorama.Fore.GREEN+text+colorama.Fore.WHITE)
    
def readfile(path) -> str:
    try:
        return str(open(path, 'r+').read())
    except open as e:
        Prints.printE('Error !')
        sys.exit()
        
# Clear exec Terminal stdout
def clearCL() -> None:
    os.system('clear')
    
# Clear exec Terminal stdout
def clearCW() -> None:
    os.system('cls')
    
# Clear exec Terminal stdout
def clearCJ() -> None:
    os.system('clear')
\n
{code}
\n
    """.replace(':=', '=').replace('pkgs main', '').replace('/*', '#').replace('*/', '#').replace('echo', 'print').replace('{|', ':').replace('|}', '').replace('<"""', '"""').replace('""">', '"""').replace('str |', 'str').replace('int |', 'int').replace('float |', 'float').replace('type |', 'type').replace('-;', '').replace('<<', '{').replace('>>', '}').replace('func ', 'def ').replace('glob', 'global').replace('complex |', 'complex').replace('tuple |', 'tuple').replace('range |', 'range').replace('dict |', 'dict').replace('set |', 'set').replace('frozenset |', 'frozenset').replace('bool |', 'bool').replace('bytes |', 'bytes').replace('bytearray |', 'bytearray').replace('memoryview |', 'memoryview').replace('null |', 'None').replace('len |', 'len').replace(' :in: ', ' in ').replace('@$', 'not').replace('<<>>', 'or').replace('<>', 'and').replace('::', ':').replace('str_upper()', 'upper()').replace('str_lower()', 'lower()').replace('str_strip()', 'strip()').replace('str_split', 'split').replace('format |', 'format').replace('else if', 'elif').replace('true |', 'True').replace('false |', 'False').replace('public |', '').replace('private |', '_').replace(' new ', '').replace('argv()', 'sys.argv').replace('pt%', '').replace('%pt', '').replace('sleep(', 'time.sleep(').replace('&;', '').replace('--', '     ').replace('&', '')

    open('Log.txt', 'a').write(f"\n \n Run Date: {now}")
    printW('=================================')
    runcode(codes)
    printW('=================================')
    printO('Finish code .')
    sys.exit()
# except:
#     clear_cmd()
#     printE('Proton Error ! ):')
#     sys.exit()